import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import de.bezier.data.sql.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class SwissCorrelation extends PApplet {

//Data & Big Data
//by mohit hingorani
// assignment 3 correlating data
//Seattle Public Library Data
//starting form scratch



String baseURL = "http://api.nytimes.com/svc/search/v2/articlesearch";
String APIkey = "362412324bfd4d15c3937caa04125f28:9:68817159";

//font helvetica
PFont myHelvetica12 = createFont("Helvetica",12,true);
PFont myHelvetica16 = createFont("Helvetica",16,true);
PFont myHelvetica53 = createFont("Helvetica",51,true);
PFont myHelvetica14 = createFont("Helvetica",14,true);
PFont myHelvetica35 = createFont("Helvetica",35,true);
//background sizes  
int scale=2;
int width= 1080/scale;
int height= 1920/scale;
//margins
int topMargin = width/20;
int bottomMargin = width/20;
int leftMargin = width/20;
int rightMargin = width/20; 

int pointer;
//white is 255  (think of it as too bright)(max light)
//black is 0    (think of it as dark) (no light)

Table data,bigdata;
int rows=36;
int brows=4;
float maxDataBooks;
float maxBigDataBooks;
int i;
float [] dataMatrix =null;
float [] bigDataMatrix =null;
int barWidth=20;
String[] words= {"data","big+data"};


int frequency;
int [] bigDataNumbers=null;
int [] dataNumbers= null;
int heightChange=14;

public int getArticleKeywordCount(String word, String beginDate, String endDate) {

  int total = 0;
  String filename = "nyttmp2.json";

  try  {
    String request = "";
    request += baseURL + ".json";
    request += "?q=" + word;
    request += "&facet_field=source";
    request += "&facet_filter=true";
    request += "&begin_date=" + beginDate;
    request += "&end_date=" + endDate;
    request += "&api-key=" + APIkey;
    
    println(request);
    
    JSONObject  root = loadJSONObject(request);
    JSONObject  response = root.getJSONObject("response");
    JSONObject  facets = response.getJSONObject("facets");
    JSONObject  source = facets.getJSONObject("source");
    total = source.getInt("total");
    
  } catch (Exception e)  {
    e.printStackTrace();
  }

  return total;
};
 
public void draw()
      {
        
       
       //drawing data for SPL
       for (i=0;i<rows;i++)
            {
              stroke(255,0,0);
              strokeWeight(0.8f);
              fill(220);
              //rect x,y,width,height 
             rect(width/2-5*dataMatrix[i]*maxDataBooks,5*topMargin+i*barWidth,5*dataMatrix[i]*maxDataBooks,barWidth ) ;
            }   
        
        for (i=0;i<rows;i++)
            {
              stroke(255,0,0);
              strokeWeight(0.8f);
              fill(255);
              //rect x,y,width,height 
             rect(width/2-5*bigDataMatrix[i],5*topMargin+i*barWidth,5*bigDataMatrix[i],barWidth ) ;
            }
        
        
        for (int i= 0 ; i<words.length;i++)
         {  
          for(int counter=0; counter<36;counter++)
              {
                
                drawDataNYT(dataNumbers[counter],counter);
              }
         }  
      
       for (int i= 0 ; i<words.length;i++)
         {  
          for(int counter=0; counter<36;counter++)
              {
                
                drawBigDataNYT(bigDataNumbers[counter],counter);
              }
         }     
  ///////////////adding interactivity////////////////
       
        if (  mouseY>(5*topMargin) && mouseY<(5*topMargin +barWidth*rows)  )
            { 
              
              pointer = (mouseY-(5*topMargin))/20;
              //left side
              
              if ( mouseX < (width/2)-(bigDataMatrix[pointer]*5) && mouseX < (width/2 -dataMatrix[pointer]*5))
                  {                  
                   fill(255,0,0,222);
                   textFont(myHelvetica12);
                   textAlign(LEFT,CENTER);  
                   text(PApplet.parseInt(dataMatrix[pointer]*maxDataBooks),mouseX-20,mouseY);                                  
                   
                  }
              if ( mouseX < (width/2) && mouseX >= width/2 -(bigDataMatrix[pointer]*5) ) 
                  {                  
                   fill(255,0,0,222);
                   textFont(myHelvetica12);
                   textAlign(LEFT,CENTER);  
                   text(PApplet.parseInt(bigDataMatrix[pointer]),mouseX-20,mouseY);
                  }    
              
              // right side   
              
              if (mouseX > width/2+(bigDataNumbers[pointer]/10) && mouseX < (width/2 + dataNumbers[pointer]/10))
                  {                  
                   fill(255,255,255,222);
                   textFont(myHelvetica12);
                   textAlign(LEFT,CENTER);  
                  // if (useX>(width/2)+dataNumbers[pointr]/12)                
                   text(dataNumbers[pointer],mouseX+10,mouseY);
            
                  }    
               else if (mouseX > width/2 && mouseX < width/2+(bigDataNumbers[pointer]/10))
                   {
                     fill(255,255,255,222);
                     textFont(myHelvetica12);
                     textAlign(LEFT,CENTER); 
                     text(bigDataNumbers[pointer],mouseX+10,mouseY);
                   }   
            }     
           
        ////trial for nyt//////
        /*
        for (i=0;i<rows;i++)
            {
              stroke(255);
              fill(255,0,0);
              //rect x,y,width,height 
             rect(width/2,5*topMargin+i*barWidth,5*dataMatrix[i]*maxDataBooks/2,barWidth ) ;
            }
            
        */    
        // end of the last bracket
        
      //save("completedata.jpg") ; 
      }
      
public void drawDataNYT(int localFrequency,int localCounter)
                    {
                      stroke(255);
                      strokeWeight(0.8f);
                      fill(220,0,0);
                      rect(width/2,5*topMargin+localCounter*barWidth,localFrequency/10,barWidth ) ;
                    }
public void drawBigDataNYT(int localFrequency,int localCounter)
                    {
                      stroke(255);
                      strokeWeight(0.8f);
                      fill(255,0,0);
                      rect(width/2,5*topMargin+localCounter*barWidth,localFrequency/10,barWidth ) ;
                    }                    
public void setup()
    {
       ///dates    
     
     String start= "20090101";
     String end = "20090202";
     
     // year 2011 only
     String[] startDates= {"20110101","20110201","20110301","20110401","20110501","20110601","20110701","20110801","20110901","20111001","20111101","20111201",
                           "20120101","20120201","20120301","20120401","20120501","20120601","20120701","20120801","20120901","20121001","20121101","20121201",
                           "20130101","20130201","20130301","20130401","20130501","20130601","20130701","20130801","20130901","20131001","20131101","20131201"
                                                      
                         };
     String[] endDates= {"20110131","20110228","20110331","20110430","20110531","20110630","20110731","20110831","20110930","20111031","20111130","20111231",
                         "20120131","20120228","20120331","20120430","20120531","20120630","20120731","20120831","20120930","20121031","20121130","20121231",
                         "20130131","20130228","20130331","20130430","20130531","20130630","20130731","20130831","20130930","20131031","20131130","20131231"
   
 
                         };
    
     // canvas
     size(width,height);
     smooth();
     background(255);
     fill(255,0,0);
     noStroke();
     rect(0,0,width/2,height);
     
     //titles etc
     /*
     textFont(myHelvetica53);
     textAlign(LEFT,TOP);
     fill(255);
     text("DATA      &",leftMargin/3,topMargin/3);
     text("BIG  DATA",leftMargin/3,topMargin/3+45);
     textFont(myHelvetica14);
     
     
     textAlign(LEFT,TOP);
     fill(255,0,0);
     text("Data Correlation:",width/2+leftMargin/3,topMargin/3);
     text("SPL: Checkouts in books with the  ",width/2+leftMargin/3,topMargin/3+heightChange);    
     text("word 'Data' & 'Big Data' ",width/2+leftMargin*5/3,topMargin/3+2*heightChange); 
     text("NYT: Number of times 'data'& 'big data'  ",width/2+leftMargin/3,heightChange*3+topMargin/3);
     text("turned up in the article search  ",width/2+leftMargin*5/3,4*heightChange+ topMargin/3);
     */
     
     /// messing around with titles
     
     
     textFont(myHelvetica35);
     textAlign(LEFT,TOP);
     fill(255);
     text("DATA      &",leftMargin/3,topMargin/3);
     text("BIG  DATA",leftMargin/3,topMargin/3+35);
     textFont(myHelvetica12);
     textAlign(LEFT,TOP);
     fill(255,0,0);
     text("Data Correlation:",width/2+leftMargin/3,topMargin/3);
     text("SPL: Checkouts in books with the  ",width/2+leftMargin/3,topMargin/3+heightChange);    
     text("word 'Data' & 'Big Data' ",width/2+leftMargin*5/3,topMargin/3+2*heightChange); 
     text("NYT: Number of times 'data'& 'big data'  ",width/2+leftMargin/3,heightChange*3+topMargin/3);
     text("turned up in the article search  ",width/2+leftMargin*5/3,4*heightChange+ topMargin/3);
     
     
     
     textFont(myHelvetica12);
     textAlign(CENTER,CENTER);
     fill(255,0,0);
     text("By Mohit Hingorani || MAT259 || Assignment 3",0.75f*width,height-bottomMargin/3);
     
     textFont(myHelvetica16);
     textAlign(CENTER,CENTER);
     fill(255);
     text("Seattle Public Library ",width/4,height-2*bottomMargin);
     
     
     textFont(myHelvetica16);
     textAlign(CENTER,CENTER);
     fill(255,0,0);
     text("New York Times ",3*width/4,height-2*bottomMargin);
     //getting years (barWidth11-barWidth13)
     int yearCount=2011;
     while(yearCount<2014)
            {
             textFont(myHelvetica16);
             textAlign(LEFT,TOP);
             fill(255);
             text(yearCount,leftMargin/3,(yearCount-2010)*barWidth*12-5*barWidth);
             
             textFont(myHelvetica16);
             textAlign(RIGHT,TOP);
             fill(255,0,0);
             text(yearCount,width-leftMargin/3,(yearCount-2010)*barWidth*12-5*barWidth);
             yearCount++;
            }
     /////// lines       
     for (i=0;i<5;i++)
         { 
           stroke(255,0,0);
           line(width-leftMargin/3,i*barWidth*12-5*barWidth-4,width-(leftMargin+barWidth*4),i*barWidth*12-5*barWidth-4);       
           stroke(255);
           line(leftMargin/3,i*barWidth*12-5*barWidth-4,leftMargin+barWidth*4,i*barWidth*12-5*barWidth-4);
         }      
          
     // initializing the tables
     
     data = new Table();
     bigdata = new Table();
     
     data= loadTable("data.csv","header");
     bigdata= loadTable("bigdata.csv","header");
     
     //extracting tables from DATA CSV files
     
     //creating the datamatrix
      dataMatrix = new float [rows];
      bigDataMatrix = new float [rows];
      dataNumbers= new int[rows];
      bigDataNumbers=new int [rows];
      
      
      //extracting form the CSV file
      
      for (i=0;i<rows;i++)
          {
            dataMatrix[i]= data.getInt(i,2);
          }
      for (i=0;i<rows;i++)
          {  
            if (i<rows-4)
                bigDataMatrix[i] = 0;
            else    
                bigDataMatrix[i]= bigdata.getInt(i-32,2);
          }    
      
      //finding the maximum number of books
      
      maxDataBooks=dataMatrix[0];
      for(i=0;i<rows;i++)
          {
          if (maxDataBooks<dataMatrix[i])
              {
                maxDataBooks=dataMatrix[i];
              }
           }
     for (i=0;i<rows;i++)
          {
            dataMatrix[i]= dataMatrix[i]/maxDataBooks;
          }          
           
   //messing with NYT
   
     for (int i= 0 ; i<words.length;i++)
         {  
        for(int counter=0; counter<36;counter++)
            {
            frequency= getArticleKeywordCount( words[i], startDates[counter], endDates[counter]); 
            println(frequency);
            
            if(i==0)
                {
                  dataNumbers[counter]=frequency;
                }
            if(i==1)
                {
                  bigDataNumbers[counter]=frequency;
                }
                
           
            
            }
         }  
    
          
    //end of the last setup bracket
    }    
  
     
     
     
    


  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "--full-screen", "--bgcolor=#666666", "--stop-color=#cccccc", "SwissCorrelation" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
